//+------------------------------------------------------------------+
//|                                                 a_MMM_Europa.mq4 |
//|                                     |
//|                                      |
//|                           Bookkeeper, 2006, yuzefovich@gmail.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Aqua
#property indicator_color2  LemonChiffon
#property indicator_color3  Magenta
#property indicator_color4  Magenta
#property indicator_color5  Magenta
#property indicator_color6  Black

extern int FirstWorkHour =7; // Asia =1, Eur =7, USA =14
extern int LastWorkHour =15;  // Asia =9 ( < 10:00), Eur =15 ( < 16:00), USA =22 ( < 23:00)

int ExtCountedBars=0, Shift=0; 
bool first=True;

double  ColorBars1_Bufer[];
double  ColorBars2_Bufer[];
double  Lw_Bufer[];
double  Hgh_Bufer[];
double  SMA_Bufer[];
double  SumMdl_Bufer[];

//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(0,ColorBars1_Bufer);
   SetIndexBuffer(1,ColorBars2_Bufer);
   SetIndexBuffer(2,Lw_Bufer);
   SetIndexBuffer(3,Hgh_Bufer);
   SetIndexBuffer(4,SMA_Bufer);
   SetIndexBuffer(5,SumMdl_Bufer);
   return(0);
}
//+------------------------------------------------------------------+
int start()
{
int    curPeriod=0, nMdl;
   if (FirstWorkHour < 0) return(-1); // ,  
   if (LastWorkHour > 23) return(-1);
   if (FirstWorkHour > LastWorkHour) return(-1);
   if (curPeriod!=Period()) first=True; //     -    
   if (first==True)  //   FirstWorkHour  
   {
      Shift = Bars-1;
      curPeriod=Period();
      if (curPeriod>60) return(-1); //   ,   
      while (first==True) 
      {
         Shift--;
         if(TimeHour(Time[Shift])==FirstWorkHour && 
            TimeHour(Time[Shift+1])!=FirstWorkHour) 
         {   
            first = False; // 
            ColorBars1_Bufer[Shift] = High[Shift];
            ColorBars2_Bufer[Shift] = Low[Shift];
            Lw_Bufer[Shift] = Low[Shift];
            Hgh_Bufer[Shift] = High[Shift];
            SumMdl_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
            nMdl=Shift;
            SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         }   
         if (Shift< 2) return(-1); //  ...
      } 
   } 
   else //   FirstWorkHour    -  - 
   {
      ExtCountedBars=IndicatorCounted();
      if (ExtCountedBars<0) return(-1);
      if (ExtCountedBars>0) ExtCountedBars--;
      Shift = Bars-ExtCountedBars-1;
   } 
   while (Shift > 0) // , 
   {
      if(TimeHour(Time[Shift]) == FirstWorkHour && 
         TimeHour(Time[Shift+1]) != FirstWorkHour) //   
      {
               ColorBars1_Bufer[Shift] = High[Shift];
               ColorBars2_Bufer[Shift] = Low[Shift];
         Lw_Bufer[Shift] = Low[Shift];
         Hgh_Bufer[Shift] = High[Shift];
         SumMdl_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         nMdl=Shift;
         SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         Shift--;
      } 
      else //   
      {
         while((TimeHour(Time[Shift])>=FirstWorkHour) && 
               (TimeHour(Time[Shift])<=LastWorkHour) && (Shift>0))
         {
            if(TimeHour(Time[Shift])<FirstWorkHour+3) //  3   
            {   
               ColorBars1_Bufer[Shift] = High[Shift];
               ColorBars2_Bufer[Shift] = Low[Shift];
            } 
            if((TimeHour(Time[Shift])>=FirstWorkHour+3) &&
               (TimeHour(Time[Shift])<LastWorkHour-1))
            {   
               ColorBars1_Bufer[Shift] = Low[Shift];
               ColorBars2_Bufer[Shift] = High[Shift];
            }
            if(TimeHour(Time[Shift])>=LastWorkHour-1) //  2   
            {   
               ColorBars1_Bufer[Shift] = High[Shift];
               ColorBars2_Bufer[Shift] = Low[Shift];
            } 
            if(Lw_Bufer[Shift+1] > Low[Shift]) Lw_Bufer[Shift] = Low[Shift];
            else Lw_Bufer[Shift] = Lw_Bufer[Shift+1];
            if(Hgh_Bufer[Shift+1] < High[Shift]) Hgh_Bufer[Shift] = High[Shift];
            else Hgh_Bufer[Shift] = Hgh_Bufer[Shift+1];
            SumMdl_Bufer[Shift] = SumMdl_Bufer[Shift+1]+(Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
//            SMA_Bufer[Shift] = SumMdl_Bufer[Shift]/(nMdl-Shift+1);  //      
            SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2; //    
            Shift--;
         }
      } 
      while(((TimeHour(Time[Shift])<FirstWorkHour) || 
             (TimeHour(Time[Shift])>=LastWorkHour)) && 
             (Shift>0))                                //   
      {
         Shift--;                        
         SumMdl_Bufer[Shift] = EMPTY_VALUE;
         SMA_Bufer[Shift] = EMPTY_VALUE;
         Hgh_Bufer[Shift] = EMPTY_VALUE;
         Lw_Bufer[Shift] = EMPTY_VALUE;
         ColorBars1_Bufer[Shift] = EMPTY_VALUE;
         ColorBars2_Bufer[Shift] = EMPTY_VALUE;
      }
   }
   return(0);
}

